#!/usr/bin/python
# Copyright 2017 Cumulus Networks Inc, all rights reserved
#
# datapath-utils --
#
#
#
#
#
#
#

import sys
import os
import re
import time
import logging
import logging.handlers
import traceback

import cumulus.platform
import cumulus.platforms

# initialize the global logger
global logger
logger = logging.getLogger('datapath-utils')
fmt = logging.Formatter(fmt='%(name)s %(levelname)s: %(message)s')
handler = logging.handlers.SysLogHandler('/dev/log')
handler.setFormatter(fmt)
logger.setLevel(logging.INFO)
logger.addHandler(handler)

# ----------------------------------------------------------
def is_platform_vx():
    platform_object = cumulus.platforms.probe()
    chip = platform_object.switch.chip
    if isinstance(chip, cumulus.platform.VXChip):
        return True

# ----------------------------------------------------------
#
class DatapathUtils(object) :
    def __init__(self) :
        pass

    # ----------------------------------------------------------
    def get_chip(self):

        # fetch the chip object
        platform_object = cumulus.platforms.probe()
        chip = platform_object.switch.chip
        if chip == None :
            logger.error('chip not found')
            return None
        return chip

    # ----------------------------------------------------------

    def get_config_files(self, chip) :

        file_dict = {}
        usr_config_dir  = '/etc/cumulus/datapath/'

        if chip == None :
            logger.error('Chip is of NoneType')
            return config_file_dict

        if isinstance(chip, cumulus.platform.BCMChip) :
            chip_config_dir = '/etc/bcm.d/datapath/'
        elif isinstance(chip, cumulus.platform.SpectrumChip) :
            chip_config_dir = '/etc/mlx/datapath/'
        else :
            logger.error('Chip %s not supported' % chip.__class__.__name__)
            return config_file_dict

        file_dict['monitor']  = usr_config_dir  + 'monitor.conf'
        # file_dict['traffic']  = usr_config_dir  + 'traffic.conf'
        # file_dict['datapath'] = chip_config_dir + 'datapath.conf'
        # file_dict['hw_desc']  = chip_config_dir + 'hw_desc'

        # check that the config files exist
        for file_key in file_dict.keys() :
            if not os.path.isfile(file_dict[file_key]) :
                file_dict[file_key] = None

        return file_dict
